//**********************************************************************
// LifePrefs Class File
// Holds all settings configured in the 'Preferences' dialog.
//******************************************************

import java.awt.*;

public class LifePrefs
{
	public int liveRules;
	public int deadRules;
	public Color foreColor;
	public Color backColor;
	public boolean showAge;
	public int selectedPreset;
	public boolean torus;
	public boolean llama;
	
	public void set (int newLive, int newDead, Color newFore, Color newBack,
							boolean newShowAgeFlag)
	{
		liveRules = newLive;
		deadRules = newDead;
		newFore = foreColor;
		newBack = backColor;
		showAge = newShowAgeFlag;
	}
	
	public LifePrefs ()
	{
		foreColor = Color.white;
		backColor = Color.black;
		liveRules = 12;
		deadRules = 8;
		showAge = false;
		selectedPreset = 0;
		torus = false;
		llama = false;
	}
	
	public void printMe ()
	{
		System.out.println("Live seed:" + liveRules);
		System.out.println("Dead seed:" + deadRules);
		System.out.println("Foreground:" + foreColor);
		System.out.println("Background:" + backColor);
		System.out.println("Show Age Flag: " + showAge);
	}
}