//**********************************************************************
// dnaFileFilter Class File
// A class for filtering files in open/save boxes so that
// only .dna files are displayed.
//******************************************************

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

public class dnaFileFilter extends FileFilter
{
	public boolean accept(File f)
	{
		if (f.isDirectory())
			return true;
		
		String extension = getExtension(f);
	 	if (extension != null)
		{
			if (extension.equals("dna"))
				return true;
			else return false;
		}
		else
		{
			return false;
		}
	}
	
	public String getDescription ()
	{
		return "Life DNA Files";
	}
	
	public String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }
}