//**********************************************************************
// GUI Class File
// Application logic and user interface code.
//******************************************************

import javax.swing.*;
import java.awt.event.*;
import javax.swing.JFrame;
import java.util.Random;

public class gui
{
	static LifePanel petriDish;
	static MenuListener ml;
	public static void main (String[] args)
	{

		
		petriDish = new LifePanel();

		JFrame frame = new JFrame ("Life");
		frame.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
		ml = new MenuListener();
		frame.setJMenuBar(ml.createMenuBar());
		
		frame.getContentPane().add(petriDish);
		
		frame.pack();
		frame.setVisible(true);
	
	}
	
	private static class MenuListener implements ActionListener, ItemListener
	{
		JMenuBar menuBar;
		JMenu file;
		JMenuItem fileOpen;
		JMenuItem fileSave;
		JMenuItem fileQuit;
		JMenu edit;
		JMenuItem editClear;
		JMenuItem editRandomize;
		JMenuItem editPrefs;
		JMenu view;
		JMenuItem viewGrid;
		JMenuItem viewZoomIn;
		JMenuItem viewZoomOut;
		JMenuItem viewZoomDefault;	
		
		public MenuListener ()
		{
			menuBar = new JMenuBar();
			file = new JMenu("File");
			view = new JMenu("View");
			edit = new JMenu("Edit");
			fileOpen = new JMenuItem("Open", KeyEvent.VK_O);
			fileOpen.addActionListener(this);
			fileSave = new JMenuItem("Save", KeyEvent.VK_S);
			fileSave.addActionListener(this);
			fileQuit = new JMenuItem("Quit", KeyEvent.VK_Q);
			fileQuit.addActionListener(this);
			file.add(fileOpen);
			file.add(fileSave);
			file.addSeparator();
			file.add(fileQuit);
			editClear = new JMenuItem("Clear", KeyEvent.VK_DELETE);
			editClear.addActionListener(this);
			editRandomize = new JMenuItem("Randomize...", KeyEvent.VK_R);
			editRandomize.addActionListener(this);
			editPrefs = new JMenuItem("Preferences", KeyEvent.VK_P);
			editPrefs.addActionListener(this);			
			edit.add(editClear);
			edit.add(editRandomize);
			edit.addSeparator();
			edit.add(editPrefs);
			viewGrid = new JMenuItem("Grid", KeyEvent.VK_G);
			viewGrid.addActionListener(this);
			view.add(viewGrid);
			view.addSeparator();
			viewZoomIn = new JMenuItem("Zoom In", KeyEvent.VK_I);
			viewZoomIn.addActionListener(this);
			viewZoomOut = new JMenuItem("Zoom Out", KeyEvent.VK_O);
			viewZoomOut.addActionListener(this);
			viewZoomDefault = new JMenuItem("Default Zoom", KeyEvent.VK_D);
			viewZoomDefault.addActionListener(this);
			view.add(viewZoomIn);
			view.add(viewZoomOut);
			view.add(viewZoomDefault);
			menuBar.add(file);
			menuBar.add(edit);
			menuBar.add(view);
		}
		
		public JMenuBar createMenuBar()
		{
			return menuBar;
		}
			
		public void actionPerformed(ActionEvent event)
		{
			if (event.getSource() == fileOpen)
			{
				petriDish.openFile();
			}
			if (event.getSource() == fileSave)
			{
				petriDish.saveFile();
			}
			if (event.getSource() == fileQuit)
			{
				System.exit(0);
			}
			if (event.getSource() == editClear)
			{
				petriDish.doDelete();
			}
			if (event.getSource() == editPrefs)
			{
				JFrame prefsFrame = new JFrame ("Preferences");
				rulesPanel prefs = new rulesPanel(prefsFrame, petriDish.myPrefs, petriDish.dish);

				prefsFrame.getContentPane().add(prefs);
		
				prefsFrame.pack();
				prefsFrame.setVisible(true);

			}
			if (event.getSource() == editRandomize)
			{
				petriDish.randomize();
			}
			if (event.getSource() == viewGrid)
			{
				petriDish.toggleGrid();
			}
			if (event.getSource() == viewZoomIn)
			{
				petriDish.changeZoom(1);
			}
			if (event.getSource() == viewZoomOut)
			{
				petriDish.changeZoom(-1);
			}
			if (event.getSource() == viewZoomDefault)
			{
				petriDish.zoomTo(4);
			}
			
		}
		
		public void itemStateChanged(ItemEvent e)
		{
		} 
	
	
	}
}